#  as -o hello.o hello.s ; ld -o hello hello.o

.equ SYSCALL_EXIT,1	
.equ SYSCALL_WRITE,4
		
.equ STDIN,0
.equ STDOUT,1
.equ STDERR,2	
	
	.globl _start
_start:
	
	br      $27,0           # fake branch, to grab the location
	                        # of our entry point
	ldgp    $gp,0($27)      # load the GP proper for our entry point
				# this does automagic stuff...
				# gp is used for 64-bit jumps and constants
				# so if you use "la" and the like it will
				# load from gp for you.  
				

	lda	$16,hello_string  # 16=a0	
	addq	$16,8,$16
	br	$26,strlen

	#================================
	# Exit
	#================================
exit:		
        mov	$0,$16			# 0 exit value
        mov	SYSCALL_EXIT,$0		# put the exit syscall number in v0
        callsys				# and exit



	#================================
	# Strlen
	#================================
	# disassembled from glibc
	# string in a0, result in v0
strlen:	
         ldq_u   $1,0($16)
	 lda     $2,-1
         insqh   $2,$16,$2
	 andnot  $16,0x7,$0
         or      $2,$1,$1
	 nop     
         cmpbge  $31,$1,$2
         bne     $2,label90
label80: ldq     $1,8($0)
         addq    $0,0x8,$0
         cmpbge  $31,$1,$2
	 beq     $2,label80
label90: negq    $2,$3
	 and     $2,$3,$2
	 and     $2,0xf0,$3
	 and     $2,0xcc,$4
	 and     $2,0xaa,$5
	 cmovne  $3,0x4,$3
         cmovne  $4,0x2,$4
	 cmovne  $5,0x1,$5
	 addq    $3,$4,$3
	 addq    $0,$5,$0
	 addq    $0,$3,$0
         nop     
         subq    $0,$16,$0
         ret
	 nop   




#===========================================================================
.data
#===========================================================================

hello_string:		.ascii  "TESTVince is cool!\n\0"
