.include "../common/syscalls.i386"

	.globl _start	
_start:	

	# get getuid()
	
	mov	$uid_result,%ecx
	call	write_stdout

	mov	$SYSCALL_GETUID,%eax
	int	$0x80

	call	num_to_ascii	
	call	print_lf	

	# get geteuid()
	
	mov	$euid_result,%ecx
	call	write_stdout

	mov	$SYSCALL_GETEUID,%eax
	int	$0x80

	call	num_to_ascii	
	call	print_lf	


	# test getuid32()

	mov	$uid32_result,%ecx
	call	write_stdout

	mov	$SYSCALL_GETUID32,%eax
	int	$0x80

	call	num_to_ascii	
	call	print_lf
	
	# test geteuid32()

	mov	$euid32_result,%ecx
	call	write_stdout

	mov	$SYSCALL_GETEUID32,%eax
	int	$0x80

	call	num_to_ascii	
	call	print_lf	
	
	# get getgid()
	
	mov	$gid_result,%ecx
	call	write_stdout

	mov	$SYSCALL_GETGID,%eax
	int	$0x80

	call	num_to_ascii	
	call	print_lf	

	# get getegid()
	
	mov	$egid_result,%ecx
	call	write_stdout

	mov	$SYSCALL_GETEGID,%eax
	int	$0x80

	call	num_to_ascii	
	call	print_lf	


	# test getgid32()

	mov	$gid32_result,%ecx
	call	write_stdout

	mov	$SYSCALL_GETGID32,%eax
	int	$0x80

	call	num_to_ascii	
	call	print_lf
	
	# test getegid32()

	mov	$egid32_result,%ecx
	call	write_stdout

	mov	$SYSCALL_GETEGID32,%eax
	int	$0x80

	call	num_to_ascii	
	call	print_lf	

	# fall through to exit

.include "../common/library.i386"

.data

uid_result:	.ascii	"getuid result:      \0"
euid_result:	.ascii	"geteuid result:     \0"
uid32_result:	.ascii	"getuid32 result:    \0"
euid32_result:	.ascii	"geteuid32 result:   \0"

gid_result:	.ascii	"getgid result:      \0"
egid_result:	.ascii	"getegid result:     \0"
gid32_result:	.ascii	"getgid32 result:    \0"
egid32_result:	.ascii	"getegid32 result:   \0"

