.include "../common/syscalls.mipsO32"

	.globl __start	
__start:	

#
# Double add
#

#        la      $5,double_add
#	jal	write_stdout

#	la	$5,temp_addr
	
#	li	$4,1000
#	sd	$4,0($5)		# store 1000 to memory
	
#	ldc1	$f2,0($5)		# load into fp reg f2
	
#	li	$4,3000
#	sd	$4,0($5)		# store 3000 to memory
	
#	ldc1	$f4,0($5)		# load into fp reg f4	
	
#	la	$5,temp_addr	
#	sdc1	$f2,0($5)
#	ld	$4,0($5)
#	jal	print_decimal
#	jal	print_lf
	
#	la	$5,plus
#	jal	write_stdout
	
#	la	$5,temp_addr	
#	sdc1	$f4,0($5)
#	ld	$4,0($5)
#	jal	print_decimal
#	jal	print_lf	

#	la	$5,equals
#	jal	write_stdout

#	cvt.d.w	$f2,$f2
#	cvt.d.w	$f4,$f4
#	add.d	$f6,$f2,$f4	
	
#	cvt.w.d	$f6,$f6
	
#	la	$5,temp_addr	
#	sdc1	$f6,0($5)
#	ld	$4,0($5)
#	jal	print_decimal
#	jal	print_lf
#	jal	print_lf
	
#	la	$5,temp_addr	
#	ld	$4,0($5)
#	li	$5,4000
#	bne	$4,$5,wrong

#
# Single Add
#
	
	la      $5,single_add
	jal	write_stdout

	la	$5,temp_addr
	
	li	$4,2000
	sw	$4,0($5)		# store 1000 to memory
	
	lwc1	$f2,0($5)		# load into fp reg f2
	
	li	$4,6000
	sw	$4,0($5)		# store 3000 to memory
	
	lwc1	$f4,0($5)		# load into fp reg f4	
	
	la	$5,temp_addr	
	swc1	$f2,0($5)
	lw	$4,0($5)
	jal	print_decimal
	jal	print_lf
	
	la	$5,plus
	jal	write_stdout
	
	la	$5,temp_addr	
	swc1	$f4,0($5)
	lw	$4,0($5)
	jal	print_decimal
	jal	print_lf	

	la	$5,equals
	jal	write_stdout

	cvt.s.w	$f2,$f2
	cvt.s.w	$f4,$f4
	add.s	$f6,$f2,$f4	
	
	cvt.w.s	$f6,$f6
	
	la	$5,temp_addr	
	swc1	$f6,0($5)
	lw	$4,0($5)
	jal	print_decimal
	jal	print_lf
	jal	print_lf	

	la	$5,temp_addr	
	lw	$4,0($5)
	li	$5,8000
	bne	$4,$5,wrong
	
	
	
#
# Double Add m5
#
	
	la      $5,double_add
	jal	write_stdout

	la	$5,temp_addr
	
	li	$4,2000
	sw	$4,0($5)		# store 1000 to memory
	
	lwc1	$f2,0($5)		# load into fp reg f2
	
	li	$4,6000
	sw	$4,0($5)		# store 3000 to memory
	
	lwc1	$f4,0($5)		# load into fp reg f4	
	
	la	$5,temp_addr	
	swc1	$f2,0($5)
	lw	$4,0($5)
	jal	print_decimal
	jal	print_lf
	
	la	$5,plus
	jal	write_stdout
	
	la	$5,temp_addr	
	swc1	$f4,0($5)
	lw	$4,0($5)
	jal	print_decimal
	jal	print_lf	

	la	$5,equals
	jal	write_stdout

	cvt.d.w	$f2,$f2
	cvt.d.w	$f4,$f4
	add.d	$f6,$f2,$f4	
	
	cvt.w.d	$f6,$f6
	
	la	$5,temp_addr	
	swc1	$f6,0($5)
	lw	$4,0($5)
	jal	print_decimal
	jal	print_lf
	jal	print_lf	

	la	$5,temp_addr	
	lw	$4,0($5)
	li	$5,8000
	bne	$4,$5,wrong

good:
   	la	$5,good_string
	jal	write_stdout
   	b	after_wrong
wrong:
        la	$5,error_string
	jal	write_stdout
       

after_wrong:

	# fall through to exit

.include "../common/library.mipsO32"

.data

double_add:	.ascii	"Testing add.d!\n\0"
single_add:	.ascii	"Testing add.s!\n\0"
good_string:		.ascii  "OK!\n\0"
error_string:		.ascii  "Wrong answer!\n\0"

plus:		.ascii  "+\n\0"
equals:		.ascii  "=======\n\0"


.align 3
temp_addr:
	  	.ascii  "ABCDEFGH"
