#!/bin/sh

if [ $HOSTNAME == "chocovic" ]; then 
   stat1="instructions_retired"
elif [ $HOSTNAME == "tasse" ]; then 
   stat1="instructions_retired"
elif [ $HOSTNAME == "spruengli" ]; then 
   stat1="inst_retired"
elif [ $HOSTNAME == "ancient" ]; then 
   stat1="inst_retired"
elif [ $HOSTNAME == "nestle" ]; then 
   stat1="inst_retired"
elif [ $HOSTNAME == "itanium" ]; then 
   stat1="ia32_inst_retired"
elif [ $HOSTNAME == "jennifer" ]; then 
   stat1="retired_instructions"
elif [ $HOSTNAME == "venchi" ]; then 
   stat1="retired_instructions"
elif [ $HOSTNAME == "milka" ]; then 
   stat1="retired_instructions"
elif [ $HOSTNAME == "tobler" ]; then 
   stat1="retired_instructions"
elif [ $HOSTNAME == "domori24" ]; then 
   stat1="instr_completed:nbogus"
elif [ $HOSTNAME == "gallais" ]; then 
   stat1="instr_retired:nbogusntag"
elif [ $HOSTNAME == "sampaka12" ]; then 
   stat1="instr_retired:nbogusntag"
else   
   echo "UNKNOWN MACHINE!"
   exit
fi

pfmon -e $stat1 --outfile=/fusion/home/vince/iiswc/assembly/pagefault/$HOSTNAME.fault -- /fusion/home/vince/iiswc/assembly/pagefault/brk_fault
pfmon -e $stat1 --outfile=/fusion/home/vince/iiswc/assembly/pagefault/$HOSTNAME.nofault -- /fusion/home/vince/iiswc/assembly/pagefault/brk_nofault
