#  "as -o read_test.o read_test.s ; ld -o read_test read_test.o"

# should be 4096 memory accesses
#           4096 branches

#  2 + (4096 *3) + 4 + 1 = 12295 retired instructions


.text
	.globl _start
_start:
	mov 	$4096,%ecx		# 1 
	mov	$data,%ebx
	
load_loop:	
	movl	(%ebx),%eax		# load
	addl	$4,%ebx
	
	loop	load_loop

	
exit:
	xor     %ebx,%ebx		# exit(0) 
	xor	%eax,%eax
	inc	%eax	 		# put exit syscall number (1) in eax
	int     $0x80             	# and exit

.bss

.align 4096
.lcomm data, 16384
