
# Sycscalls
.equ SYSCALL_EXIT,    60

.text
	
	.globl _start	
_start:	


	mov	$100000,%ecx
looper:
	add	%al,%bl			# 8-bit add, reg/reg
	add	%al,int_value		# 8-bit add, reg/mem
	add	int_value,%al		# 8-bit add, mem/reg
	add	$0x5,%bl		# 8-bit add, immediate/reg
	add	$0x5,%al		# 8-bit add, immediate/%al

	add	%ax,%bx			# 16-bit add, reg/reg
	add	%ax,int_value		# 16-bit add, reg/mem
	add	int_value,%ax		# 16-bit add, mem/reg
	add	$0xbabe,%bx		# 16-bit add, immediate/reg
	add	$0xbabe,%ax		# 16-bit add, immediate/%ax

	add	%eax,%ebx		# 32-bit add, reg/reg
	add	%eax,int_value		# 32-bit add, reg/mem
	add	int_value,%eax		# 32-bit add, mem/reg
	add	$0xcafebabe,%ebx	# 32-bit add, immediate/reg
	add	$0xcafebabe,%eax	# 32-bit add, immediate/%eax
	
	add	$0x5,%bx		# 16-bit add, 8 bit constant	
	add	$0x5,%ebx		# 32-bit add, 8 bit constant

	addb	$0xca,int_value		# 8-bit add, memory
	addw	$0xcafe,int_value	# 16-bit add, memory
	addl	$0xcafebabe,int_value	# 32-bit add, memory
			
	loop	looper

#	mov	$out_buffer, %edi	# point to out_buffer
#	mov	$262144,%ecx
#	mov	$0xa5,%al
#	rep	stosb

        #================================
	# Exit
	#================================
exit:
	push	$1		# Put exit syscall in rax
	pop	%eax

	xor	%ebx,%ebx		# Make return value $0
	int	$(0x80)	
	
	
#===========================================================================
#	section .data
#===========================================================================
.data
int_value:	.int	0xdeadbeef
		
#============================================================================
#	section .bss
#============================================================================
.bss

#.align 32768			# align to a 32kB boundary
.lcomm  out_buffer,262144	# 256kB
