#  assemble with     "as -o cachetest.o cachetest.s"
#  link with         "ld -N -o cachetest cachetest.o"

# offset into the results returned by the sysinfo syscall
.equ S_TOTALRAM,32

# Sycscalls
.equ SYSCALL_EXIT,    60
.equ SYSCALL_WRITE,    1

#
.equ STDIN,0
.equ STDOUT,1
.equ STDERR,2

	.globl _start	
_start:	

	mov	$out_buffer, %edi	# point to out_buffer
	mov	$262144,%ecx
	mov	$0xa5,%al
	rep	stosb

        #================================
	# Exit
	#================================
exit:
#	push	$SYSCALL_EXIT		# Put exit syscall in rax
#	pop	%rax

#	xor	%edi,%edi		# Make return value $0
#	syscall


	push	$1		# Put exit syscall in rax
	pop	%eax

	xor	%ebx,%ebx		# Make return value $0
	int	$(0x80)	
	
	
#===========================================================================
#	section .data
#===========================================================================
.data

#============================================================================
#	section .bss
#============================================================================
.bss

.align 32768			# align to a 32kB boundary
.lcomm  out_buffer,262144	# 256kB
