# Sycscalls
.equ SYSCALL_EXIT,    60

.text
	
	.globl _start	
_start:	


	mov	$100000,%ecx
looper:
	cmp	%al,%bl			# 8-bit cmp, reg/reg
	cmp	%al,int_value		# 8-bit cmp, reg/mem
	cmp	int_value,%al		# 8-bit cmp, mem/reg
	cmp	$0x5,%bl		# 8-bit cmp, immediate/reg
	cmp	$0x5,%al		# 8-bit cmp, immediate/%al

	cmp	%ax,%bx			# 16-bit cmp, reg/reg
	cmp	%ax,int_value		# 16-bit cmp, reg/mem
	cmp	int_value,%ax		# 16-bit cmp, mem/reg
	cmp	$0xbabe,%bx		# 16-bit cmp, immediate/reg
	cmp	$0xbabe,%ax		# 16-bit cmp, immediate/%ax

	cmp	%eax,%ebx		# 32-bit cmp, reg/reg
	cmp	%eax,int_value		# 32-bit cmp, reg/mem
	cmp	int_value,%eax		# 32-bit cmp, mem/reg
	cmp	$0xcafebabe,%ebx	# 32-bit cmp, immediate/reg
	cmp	$0xcafebabe,%eax	# 32-bit cmp, immediate/%eax
	
	cmp	$0x5,%bx		# 16-bit cmp, 8 bit constant	
	cmp	$0x5,%ebx		# 32-bit cmp, 8 bit constant

        cmpb	$0xca,int_value		# 8-bit cmp, memory
	cmpw	$0xcafe,int_value	# 16-bit cmp, memory
	cmpl	$0xcafebabe,int_value	# 32-bit cmp, memory
		
		
	loop	looper

#	mov	$out_buffer, %edi	# point to out_buffer
#	mov	$262144,%ecx
#	mov	$0xa5,%al
#	rep	stosb

        #================================
	# Exit
	#================================
exit:
	push	$1		# Put exit syscall in rax
	pop	%eax

	xor	%ebx,%ebx		# Make return value $0
	int	$(0x80)	
	
	
#===========================================================================
#	section .data
#===========================================================================
.data
int_value:	.int	0xdeadbeef
		
#============================================================================
#	section .bss
#============================================================================
.bss

#.align 32768			# align to a 32kB boundary
.lcomm  out_buffer,262144	# 256kB
