# Sycscalls
.equ SYSCALL_EXIT,    60

.text
	
	.globl _start	
_start:	


	mov	$100000,%ecx
looper:
	or	%al,%bl			# 8-bit or, reg/reg
	or	%al,int_value		# 8-bit or, reg/mem
	or	int_value,%al		# 8-bit or, mem/reg
	or	$0x5,%bl		# 8-bit or, immediate/reg
	or	$0x5,%al		# 8-bit or, immediate/%al

	or	%ax,%bx			# 16-bit or, reg/reg
	or	%ax,int_value		# 16-bit or, reg/mem
	or	int_value,%ax		# 16-bit or, mem/reg
	or	$0xbabe,%bx		# 16-bit or, immediate/reg
	or	$0xbabe,%ax		# 16-bit or, immediate/%ax

	or	%eax,%ebx		# 32-bit or, reg/reg
	or	%eax,int_value		# 32-bit or, reg/mem
	or	int_value,%eax		# 32-bit or, mem/reg
	or	$0xcafebabe,%ebx	# 32-bit or, immediate/reg
	or	$0xcafebabe,%eax	# 32-bit or, immediate/%eax
	
	or	$0x5,%bx		# 16-bit or, 8 bit constant	
	or	$0x5,%ebx		# 32-bit or, 8 bit constant

        orb	$0xca,int_value		# 8-bit or, memory
	orw	$0xcafe,int_value	# 16-bit or, memory
	orl	$0xcafebabe,int_value	# 32-bit or, memory
		
	loop	looper

#	mov	$out_buffer, %edi	# point to out_buffer
#	mov	$262144,%ecx
#	mov	$0xa5,%al
#	rep	stosb

        #================================
	# Exit
	#================================
exit:
	push	$1		# Put exit syscall in rax
	pop	%eax

	xor	%ebx,%ebx		# Make return value $0
	int	$(0x80)	
	
	
#===========================================================================
#	section .data
#===========================================================================
.data
int_value:	.int	0xdeadbeef
		
#============================================================================
#	section .bss
#============================================================================
.bss

#.align 32768			# align to a 32kB boundary
.lcomm  out_buffer,262144	# 256kB
