# Sycscalls
.equ SYSCALL_EXIT,    60

.text
	
	.globl _start	
_start:	


	mov	$100000,%ecx
looper:
	xor	%al,%bl			# 8-bit xor, reg/reg
	xor	%al,int_value		# 8-bit xor, reg/mem
	xor	int_value,%al		# 8-bit xor, mem/reg
	xor	$0x5,%bl		# 8-bit xor, immediate/reg
	xor	$0x5,%al		# 8-bit xor, immediate/%al

	xor	%ax,%bx			# 16-bit xor, reg/reg
	xor	%ax,int_value		# 16-bit xor, reg/mem
	xor	int_value,%ax		# 16-bit xor, mem/reg
	xor	$0xbabe,%bx		# 16-bit xor, immediate/reg
	xor	$0xbabe,%ax		# 16-bit xor, immediate/%ax

	xor	%eax,%ebx		# 32-bit xor, reg/reg
	xor	%eax,int_value		# 32-bit xor, reg/mem
	xor	int_value,%eax		# 32-bit xor, mem/reg
	xor	$0xcafebabe,%ebx	# 32-bit xor, immediate/reg
	xor	$0xcafebabe,%eax	# 32-bit xor, immediate/%eax
	
	xor	$0x5,%bx		# 16-bit xor, 8 bit constant	
	xor	$0x5,%ebx		# 32-bit xor, 8 bit constant

	xorb	$0xca,int_value		# 8-bit xor, memory
	xorw	$0xcafe,int_value	# 16-bit xor, memory
	xorl	$0xcafebabe,int_value	# 32-bit xor, memory
	
	loop	looper

#	mov	$out_buffer, %edi	# point to out_buffer
#	mov	$262144,%ecx
#	mov	$0xa5,%al
#	rep	stosb

        #================================
	# Exit
	#================================
exit:
	push	$1		# Put exit syscall in rax
	pop	%eax

	xor	%ebx,%ebx		# Make return value $0
	int	$(0x80)	
	
	
#===========================================================================
#	section .data
#===========================================================================
.data
int_value:	.int	0xdeadbeef
		
#============================================================================
#	section .bss
#============================================================================
.bss

#.align 32768			# align to a 32kB boundary
.lcomm  out_buffer,262144	# 256kB
