! as -o instr_count.o instr_count.s ; ld -o instr_count instr_count.o

! loop has 4 instructions
! so total instruction count should be
!   g2*4 + 5
	
! g2 =          1,000   result =         4,005 (correct)
! g2 =         10,000   result =        40,006 (correct)
! g2 =        100,000   result =       400,006 (correct)
! g2 =      1,000,000   result =     4,000,006 (correct)
! g2 =     10,000,000   result =    40,000,006 (correct)
! g2 =    100,000,000   result =   400,000,006 (correct)
! g2 =  1,000,000,000	result = 4,000,000,006 (correct)

! g2 =  2,000,000,000	result = 5,852,516,357 (incorrect)
!                              = 0x1 5cd6 5005
!                   should be  = 0x1 dcd6 5005


.equ SYSCALL_EXIT,1	

	.globl _start
_start:
		
	set	2000000000,%g2
	set	0,%g3
	
loop:	
	inc	%g3    		
	cmp	%g2,%g3	
	bne	loop
	inc	%g4 	! branch delay slot
		
	!================================
	! Exit
	!================================
exit:		
        mov	0,%o0			! exit value
        mov	SYSCALL_EXIT,%g1        ! put the exit syscall number in g1
        ta      0x10			! and exit
