
# This tests a bug noticed in lucas spec2k

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	mov		$cvtsi2sd_label,%rcx
	call		write_stdout

	mov		$5,%ebx	
	cvtsi2sd 	%ebx,%xmm2
	
	movd		%xmm2,%rax
	call		print_hex
	call		print_lf
		
	mulsd  blah(%rip),%xmm2
	
	mov		$mulsd_label,%rcx
	call		write_stdout
	
	movd		%xmm2,%rax
	call		print_hex
	call		print_lf	
	
	mov		$1,%rax
	
	cvttsd2si 	%xmm2,%eax
	
	push		%rax
	mov		$mulsd_result,%rcx
	call		write_stdout
	mov		$cvttsd2si_label,%rcx
	call		write_stdout
	pop		%rax
	push		%rax
	call		print_hex
	call		print_lf

	mov		$this_is_label,%rcx
	call		write_stdout
	
	pop		%rax
	push		%rax
	call		print_decimal
	call		print_lf
	
	mov		$should_be_label,%rcx
	call		write_stdout


	mov		$cvtsi2sd_label2,%rcx
	call		write_stdout
	
	pop		%rax
	
	cvtsi2sd 	%eax,%xmm0
      
      	push	 	%rax
	
	movd		%xmm0,%rax
	call		print_hex
	call		print_lf
	
	
	pop		%rax
      
	lea    0x1(%rax),%edx
	comisd %xmm0,%xmm2
	cmovbe %eax,%edx
	add    $0x1,%rbp
        mov    %rbx,%rax
	add    $0x1,%rbx
	cmp    $0x7,%ebp
#	mov    %edx,(%r14,%rax,4)
#	jg     40035a <MAIN__+0x7a>
	cvtsi2sd %edx,%xmm1
#	movsd	 0x8113b(%rip),%xmm0        # 4814d8 <two>
	subsd  %xmm2,%xmm1

	mov    $final_result,%rcx
	call   write_stdout

	movd		%xmm1,%rax
	push		%rax
	call		print_hex
	call		print_lf
	pop		%rax
	
	shr		$32,%rax
	cmp		$0x3FC00000,%rax
	jne		bad_result
	
	mov		$good_string,%rcx
        jmp our_exit
bad_result:       
	mov	        $bad_string,%rcx

our_exit:

	call	write_stdout

	# fall through to exit

.include "../common/library.x86_64"

.data
temp:		.int  1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16

blah:		.int 0x8c000000,0x4161fdb6

cvtsi2sd_label:	 .ascii "cvtsi2sd 5->xmm2:        \0"
mulsd_label:	 .ascii "mulsd  val(%rip),%xmm2:  \0"
mulsd_result:    .ascii "   this is:    47162501.875000\n\0"
cvttsd2si_label: .ascii "cvttsd2si %xmm2,%eax:    \0"
this_is_label:	 .ascii "   this is:    \0"
should_be_label: .ascii "   should be:  47162501\n\0"
cvtsi2sd_label2:  .ascii "cvtsi2sd %eax,%xmm0:     \0"
final_result:	  .ascii "final_result:            \0"

good_string:	.ascii	"Good\n\0"
bad_string:	.ascii	"Fail\n\0"


        .comm   c,72,32
	.comm   wt,80,32
	.comm   tmp16,144,32
	.comm   p,8,8
	.comm   j,4,4
	.comm   n,4,4
						
