
# This exposes a bug in prefetching invalid addresses on m5

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	
	# valid case

	mov	$hello_string,%r9
	prefetcht0 (%r9)

	# not valid case
	
	mov     $0x8000,%r9
	prefetcht0 (%r9)
	
	mov	$good_string,%rcx
	call	write_stdout

	# fall through to exit

.include "../common/library.x86_64"

.data

hello_string:	.ascii	"Hello World!\n\0"
good_string:	.ascii	"Good\n\0"
