# New "syscall" instruction with all new values, and
#   args  %rdi=arg1, %rsi=arg2, %rdx=arg3, 
#	  %r10=arg4  %r8=arg5,  %r9=arg6
#   syscall passed in %rax, %r11 and %rcx destroyed
			
	
# Sycscalls
.equ SYSCALL_EXIT,    60
.equ SYSCALL_READ,     0
.equ SYSCALL_WRITE,    1

#
.equ STDIN,0
.equ STDOUT,1
.equ STDERR,2

	.globl _start	
_start:	

	mov    $0xc22e4400,%edi
        or     $0x107,%rdi
	mov    $0x386d4000,%esi
	or     $0x380,%rsi
        mov    %rdi,%rdx
	mov    %rsi,%rcx
before:
	imul   %rcx,%rdx
	mov    %rdx,%rcx
        shr    $0x20,%rcx
	and    $0xffffffff,%ecx
	mov    %rcx,0x58(%r14)
	mov    0x58(%r14),%rcx
	mov    $0x1f2e5800,%r8d
	or     $0x80,%r8
	mov    %r8,%r9
	mov    %rdx,%rax
	

        #================================
	# Exit
	#================================
exit:
	push    $SYSCALL_EXIT           # Put exit syscall in rax
        pop     %rax
	xor     %edi,%edi               # Make return value $0
        syscall
			
			
	#================================
	# WRITE_STDOUT
	#================================
	# ecx has string
	# eax,ebx,ecx,edx trashed
write_stdout:
	push    %rdx
	push	$SYSCALL_WRITE		# put 4 in eax (write syscall)
	pop     %rax     		# in 3 bytes of code
	
	cdq   	      			# clear edx
	
	lea	1(%rdx),%edi		# put 1 in ebx (stdout)
					# in 3 bytes of code

	mov	%ecx,%esi
	
str_loop1:
	inc	%edx
	cmpb	$0,(%rcx,%rdx)		# repeat till zero
	jne	str_loop1

	syscall  			# run the syscall
	pop	%rdx
	ret

#===========================================================================
#	section .data
#===========================================================================
.data

