
# This tests unimplemented haddps on x86_64

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	#########################
	# test xmmm/xmmm
	#########################

        cvtdq2ps      source1,%xmm0		# move 8,4,2,1 into xmm0
	cvtps2dq      %xmm0,%xmm2 		# print value in xmm0
	cvtdq2ps      source2,%xmm1	        # move 800,400,200,100 into xmm1
	cvtps2dq      %xmm1,%xmm2 		# print value in xmm1
        haddps        %xmm0,%xmm1

our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data
.balign 16
.balign 16
source1:                .int  1,2,4,8
source2:                .int 100,200,400,800
out:                    .int  16,17,18,19

temp:		.int  1,2,3,4
temp2:		.int  8,9,10,11

xmm_xmm_label:		.ascii  "\nxmm/xmm:\n\0"
xmm0_label:		.ascii	"           xmm0 = \0"
should_be1:             .ascii  "      should be = 1 2 4 8\n\0"
xmm1_label:		.ascii	"           xmm1 = \0"
should_be2:             .ascii  "      should be = 100 200 400 800\n\0"
should_be3:		.ascii	" Should be xmm0 = 1 2 4 8\n"
			.ascii	"           xmm1 = 300 1200 3 12\n\0"
haddps1:		.ascii  " haddps %xmm0,%xmm1\n\0"

xmm_same_label:		.ascii  "\nxmm/xmm same:\n\0"
haddps2:		.ascii  " haddps %xmm0,%xmm0\n\0"
should_be4:		.ascii	" Should be xmm0 = 3 12 3 12\n\0"

xmm_mem_label:		.ascii  "\nxmm/mem:\n\0"
haddps3:		.ascii  " haddps out,%xmm1\n\0"
should_be5:		.ascii	" Should be xmm0 = 1 2 4 8\n"
			.ascii	"           xmm1 = 300 1200 3 12\n\0"

space:		.ascii  " \0"

good_string:	.ascii	"Good\n\0"
bad_string:	.ascii	"Fail\n\0"
