#  "as -o 100_insns.o 100_insns.s ; ld -o 100_insns 100_insns.o"

# total is 2 + (((ecx * 2) +3) *edx) + 4 + 1
# the last 1 is because user->kernel transition adds an extra insn

# so for ecx=45 edx=1 should be 100

.text
	.globl _start
_start:
        nop
	mov 	$1,%edx			# 1 
outer_loop:	
	mov	$45,%ecx		# 2
inner_loop:
        dec	%ecx			# 2 insns for each ecx
	jnz	inner_loop			#
	
	dec	%edx			# ((ecx * 2) +2 ) * edx)
	jnz	outer_loop
	
exit:
	xor     %ebx,%ebx		# exit(0) 
	xor	%eax,%eax
	inc	%eax	 		# put exit syscall number (1) in eax
	int     $0x80             	# and exit
