#  "as -o 8B_insns.o 8B_insns.s ; ld -o 8B_insns 8B_insns.o"

# total is 3 + (((ecx * 2) +3) *edx) + 4 + 1
# the last 1 is because user->kernel transition adds an extra insn

# so for ecx=498 edx=8008008 should be 8 billion

.text
	.globl _start
_start:
	nop
        nop
	mov 	$8008008,%edx			# 1 
outer_loop:	
	mov	$498,%ecx			# 2
inner_loop:
        dec	%ecx			# 2 insns for each ecx
	jnz	inner_loop     		#
	
	dec	%edx			# ((ecx * 2) +2 ) * edx)
	jnz	outer_loop
	
exit:
	xor     %ebx,%ebx		# exit(0) 
	xor	%eax,%eax
	inc	%eax	 		# put exit syscall number (1) in eax
	int     $0x80             	# and exit
