# Sycscalls
.equ SYSCALL_EXIT,    60

.text
	
	.globl _start	
_start:	


	mov	$100000,%ecx
looper:
	mov	%al,%bl			# 8-bit mov, reg/reg
	mov	%al,int_value		# 8-bit mov, reg/mem
	mov	int_value,%al		# 8-bit mov, mem/reg
	mov	$0x5,%bl		# 8-bit mov, immediate/reg
	mov	$0x5,%al		# 8-bit mov, immediate/%al

	mov	%ax,%bx			# 16-bit mov, reg/reg
	mov	%ax,int_value		# 16-bit mov, reg/mem
	mov	int_value,%ax		# 16-bit mov, mem/reg
	mov	$0xbabe,%bx		# 16-bit mov, immediate/reg
	mov	$0xbabe,%ax		# 16-bit mov, immediate/%ax

	mov	%eax,%ebx		# 32-bit mov, reg/reg
	mov	%eax,int_value		# 32-bit mov, reg/mem
	mov	int_value,%eax		# 32-bit mov, mem/reg
	mov	$0xcafebabe,%ebx	# 32-bit mov, immediate/reg
	mov	$0xcafebabe,%eax	# 32-bit mov, immediate/%eax
	
	mov	$0x5,%bx		# 16-bit mov, 8 bit constant	
	mov	$0x5,%ebx		# 32-bit mov, 8 bit constant

	mov	%fs,%eax		# segment move

	movb	$0xba,int_value		# 8bit constant mov
	movw	$0xbabe,int_value	# 16-bit constant mov
	movl	$0xcafebabe,int_value	# 32-bit constant mov
	
	loop	looper

#	mov	$out_buffer, %edi	# point to out_buffer
#	mov	$262144,%ecx
#	mov	$0xa5,%al
#	rep	stosb

        #================================
	# Exit
	#================================
exit:
	push	$1		# Put exit syscall in rax
	pop	%eax

	xor	%ebx,%ebx		# Make return value $0
	int	$(0x80)	
	
	
#===========================================================================
#	section .data
#===========================================================================
.data
int_value:	.int	0xdeadbeef
		
#============================================================================
#	section .bss
#============================================================================
.bss

#.align 32768			# align to a 32kB boundary
.lcomm  out_buffer,262144	# 256kB
