# Sycscalls
.equ SYSCALL_EXIT,    60

.text
	
	.globl _start	
_start:	


	mov	$100000,%ecx
looper:
	sbb	%al,%bl			# 8-bit sbb, reg/reg
	sbb	%al,int_value		# 8-bit sbb, reg/mem
	sbb	int_value,%al		# 8-bit sbb, mem/reg
	sbb	$0x5,%bl		# 8-bit sbb, immediate/reg
	sbb	$0x5,%al		# 8-bit sbb, immediate/%al

	sbb	%ax,%bx			# 16-bit sbb, reg/reg
	sbb	%ax,int_value		# 16-bit sbb, reg/mem
	sbb	int_value,%ax		# 16-bit sbb, mem/reg
	sbb	$0xbabe,%bx		# 16-bit sbb, immediate/reg
	sbb	$0xbabe,%ax		# 16-bit sbb, immediate/%ax

	sbb	%eax,%ebx		# 32-bit sbb, reg/reg
	sbb	%eax,int_value		# 32-bit sbb, reg/mem
	sbb	int_value,%eax		# 32-bit sbb, mem/reg
	sbb	$0xcafebabe,%ebx	# 32-bit sbb, immediate/reg
	sbb	$0xcafebabe,%eax	# 32-bit sbb, immediate/%eax
	
	sbb	$0x5,%bx		# 16-bit sbb, 8 bit constant	
	sbb	$0x5,%ebx		# 32-bit sbb, 8 bit constant

        sbbb    $0xca,int_value         # 8-bit sbb, memory
	sbbw    $0xcafe,int_value       # 16-bit sbb, memory
	sbbl    $0xcafebabe,int_value   # 32-bit sbb, memory
		
		
	loop	looper

#	mov	$out_buffer, %edi	# point to out_buffer
#	mov	$262144,%ecx
#	mov	$0xa5,%al
#	rep	stosb

        #================================
	# Exit
	#================================
exit:
	push	$1		# Put exit syscall in rax
	pop	%eax

	xor	%ebx,%ebx		# Make return value $0
	int	$(0x80)	
	
	
#===========================================================================
#	section .data
#===========================================================================
.data
int_value:	.int	0xdeadbeef
		
#============================================================================
#	section .bss
#============================================================================
.bss

#.align 32768			# align to a 32kB boundary
.lcomm  out_buffer,262144	# 256kB
