# Sycscalls
.equ SYSCALL_EXIT,    60

.text
	
	.globl _start	
_start:	


	mov	$100000,%ecx
looper:
	sub	%al,%bl			# 8-bit sub, reg/reg
	sub	%al,int_value		# 8-bit sub, reg/mem
	sub	int_value,%al		# 8-bit sub, mem/reg
	sub	$0x5,%bl		# 8-bit sub, immediate/reg
	sub	$0x5,%al		# 8-bit sub, immediate/%al

	sub	%ax,%bx			# 16-bit sub, reg/reg
	sub	%ax,int_value		# 16-bit sub, reg/mem
	sub	int_value,%ax		# 16-bit sub, mem/reg
	sub	$0xbabe,%bx		# 16-bit sub, immediate/reg
	sub	$0xbabe,%ax		# 16-bit sub, immediate/%ax

	sub	%eax,%ebx		# 32-bit sub, reg/reg
	sub	%eax,int_value		# 32-bit sub, reg/mem
	sub	int_value,%eax		# 32-bit sub, mem/reg
	sub	$0xcafebabe,%ebx	# 32-bit sub, immediate/reg
	sub	$0xcafebabe,%eax	# 32-bit sub, immediate/%eax
	
	sub	$0x5,%bx		# 16-bit sub, 8 bit constant	
	sub	$0x5,%ebx		# 32-bit sub, 8 bit constant

        subb    $0xca,int_value         # 8-bit sub, memory
	subw    $0xcafe,int_value       # 16-bit sub, memory
	subl    $0xcafebabe,int_value   # 32-bit sub, memory
		
		
	loop	looper

#	mov	$out_buffer, %edi	# point to out_buffer
#	mov	$262144,%ecx
#	mov	$0xa5,%al
#	rep	stosb

        #================================
	# Exit
	#================================
exit:
	push	$1		# Put exit syscall in rax
	pop	%eax

	xor	%ebx,%ebx		# Make return value $0
	int	$(0x80)	
	
	
#===========================================================================
#	section .data
#===========================================================================
.data
int_value:	.int	0xdeadbeef
		
#============================================================================
#	section .bss
#============================================================================
.bss

#.align 32768			# align to a 32kB boundary
.lcomm  out_buffer,262144	# 256kB
