# Sycscalls
.equ SYSCALL_EXIT,    60

.text
	
	.globl _start	
_start:	


	mov	$100000,%ecx
looper:
	test	%al,%bl			# 8-bit test, reg/reg
	test	%al,int_value		# 8-bit test, reg/mem
	test	int_value,%al		# 8-bit test, mem/reg
	test	$0x5,%bl		# 8-bit test, immediate/reg
	test	$0x5,%al		# 8-bit test, immediate/%al

	test	%ax,%bx			# 16-bit test, reg/reg
	test	%ax,int_value		# 16-bit test, reg/mem
	test	int_value,%ax		# 16-bit test, mem/reg
	test	$0xbabe,%bx		# 16-bit test, immediate/reg
	test	$0xbabe,%ax		# 16-bit test, immediate/%ax

	test	%eax,%ebx		# 32-bit test, reg/reg
	test	%eax,int_value		# 32-bit test, reg/mem
	test	int_value,%eax		# 32-bit test, mem/reg
	test	$0xcafebabe,%ebx	# 32-bit test, immediate/reg
	test	$0xcafebabe,%eax	# 32-bit test, immediate/%eax
	
	test	$0x5,%bx		# 16-bit test, 8 bit constant	
	test	$0x5,%ebx		# 32-bit test, 8 bit constant

        testb	$0xca,int_value		# 8-bit test, memory
	testw	$0xcafe,int_value	# 16-bit test, memory
	testl	$0xcafebabe,int_value	# 32-bit test, memory
		
	
	loop	looper

#	mov	$out_buffer, %edi	# point to out_buffer
#	mov	$262144,%ecx
#	mov	$0xa5,%al
#	rep	stosb

        #================================
	# Exit
	#================================
exit:
	push	$1		# Put exit syscall in rax
	pop	%eax

	xor	%ebx,%ebx		# Make return value $0
	int	$(0x80)	
	
	
#===========================================================================
#	section .data
#===========================================================================
.data
int_value:	.int	0xdeadbeef
		
#============================================================================
#	section .bss
#============================================================================
.bss

#.align 32768			# align to a 32kB boundary
.lcomm  out_buffer,262144	# 256kB
