! as -Av8plus -o neg_test.o neg_test.s ; ld -o neg_test neg_test.o

.equ SYSCALL_EXIT,1	
.equ SYSCALL_WRITE,4
.equ STDOUT,1

	.globl _start
_start:
	
	! TEST1 

	set	test1,%o1
	call	write_stdout
	nop

tun_test1:	
	
	set	0x0010b640, %o1
	set	0xff8c7694, %o2
	
	cmp	%o1,%o2
	bneg	test1_negative
	nop
	
test1_postive:
	set	positive,%o1
	ba	test1_print
	nop
test1_negative:
	set	negative,%o1
test1_print:
	call	write_stdout
	nop

	
	! TEST2

	set	test2,%o1
	call	write_stdout
	nop

run_test2:	
	
	set	0x0010b640, %o1
	set	0x407ceb8c, %o2
	
	cmp	%o1,%o2
	bneg	test2_negative
	nop
	
test2_postive:
	set	positive,%o1
	ba	test2_print
	nop
test2_negative:
	set	negative,%o1
test2_print:
	call	write_stdout
	nop
	
		
	!================================
	! Exit
	!================================
exit:		
        mov	0,%o0			! exit value
        mov	SYSCALL_EXIT,%g1        ! put the exit syscall number in g1
        ta      0x10			! and exit


        !================================
	! WRITE_STDOUT
	!================================
	! %o1 has string

write_stdout:
	set     SYSCALL_WRITE,%g1       ! Write syscall in %g1
	set     STDOUT,%o0              ! 1 in %o0 (stdout)
	set     0,%o2                   ! 0 (count) in %o2

str_loop1:
	ldub    [%o1+%o2],%l0           ! load byte
	cmp     %l0,%g0                 ! compare against zero
	bnz     str_loop1               ! if not nul, repeat
	! BRANCH DELAY SLOT
	inc     %o2                     ! increment count

	dec     %o2                     ! correct count
	ta      0x10                    ! run the syscall

	retl                            ! return
	nop
		
.data
negative:	.ascii "Negative\n\0"
positive:	.ascii "Positive\n\0"
test1:	.ascii "Test1: 0010b640 - ff8c7694 : \0"
test2:	.ascii "Test1: 0010b640 - 407ceb8c : \0"

	