.include "../common/syscalls.i386"

	.globl _start	
_start:	

	# time   13

	# normal way

	mov	$time_message,%ecx
	call	write_stdout
	
	xor	%ebx,%ebx   		# NULL pointer, don't want a copy
	mov     $SYSCALL_TIME, %eax
	int	$0x80

	call    print_decimal
	call	print_lf
	
	# in mem

	mov	$mem_message,%ecx
	call	write_stdout
	
	mov	$time_mem,%ebx
	mov     $SYSCALL_TIME, %eax
	int	$0x80
	
	mov     time_mem,%eax

	call    print_decimal
	call	print_lf	

        jmp	our_exit
	
fail:	
	mov	$fail_message,%ecx
	call	write_stdout
	jmp	our_exit

our_exit:

	# fall through to exit

.include "../common/library.i386"

.data
time_message:	.ascii  "Time since 1 January 1970 : \0"
mem_message:    .ascii  " same time, written to mem: \0"
fail_message:	.ascii  "FAIL!\n\0"

time_mem:	.ascii "ABCD\0"

