
# This tests unimplemented haddps on x86_64

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	#########################
	# test xmmm/xmmm
	#########################

	mov	      $xmm_xmm_label,%rcx	# print heading
	call	      write_stdout

        cvtdq2ps      source1,%xmm0		# move 8,4,2,1 into xmm0

	mov	      $xmm0_label,%rcx		# print xmm0=
	call	      write_stdout

	cvtps2dq      %xmm0,%xmm2 		# print value in xmm0
	call	      print_s_xmm2

	mov	      $should_be1,%rcx
	call	      write_stdout
	        
	cvtdq2ps      source2,%xmm1	        # move 800,400,200,100 into xmm1

	mov	      $xmm1_label,%rcx		# print xmm1=
	call	      write_stdout

	cvtps2dq      %xmm1,%xmm2 		# print value in xmm1
	call	      print_s_xmm2

	mov	      $should_be2,%rcx
	call	      write_stdout

	#################
	# all this to test this insn
	#################

	mov	      $haddps1,%rcx
	call	      write_stdout  	# print "haddaps %xmm0,%xmm1"

        haddps        %xmm0,%xmm1
	
	# xmm1 = (s2+s3) + (s0+s1) + (d2+d3) + (d0+d1)
	#      =    12        3        1200      300
			

	#################
	# Print result
	#################
	
	mov	      $xmm0_label,%rcx		# print xmm0=
	call	      write_stdout

	cvtps2dq      %xmm0,%xmm2 		# print value in xmm0
	call	      print_s_xmm2
 
	mov	      $xmm1_label,%rcx		# print xmm1=
	call	      write_stdout

	cvtps2dq      %xmm1,%xmm2 		# print value in xmm1
	call	      print_s_xmm2

	mov	      $should_be3,%rcx
	call	      write_stdout

	# check answers
	
	cvtps2dq      %xmm1,%xmm2 		# print value in xmm1

	mov	      $300,%r9d
	mov	      $1200,%r10d
	mov	      $3,%r11d
	mov	      $12,%r12d
	call	      compare_s_xmm2
	
	#########################
	# test xmmm/xmmm on same reg
	#########################

	mov	      $xmm_same_label,%rcx	# print heading
	call	      write_stdout

        cvtdq2ps      source1,%xmm0		# move 8,4,2,1 into xmm0

	mov	      $xmm0_label,%rcx		# print xmm0=
	call	      write_stdout

	cvtps2dq      %xmm0,%xmm2 		# print value in xmm0
	call	      print_s_xmm2

	mov	      $should_be1,%rcx
	call	      write_stdout
	        
	#################
	# all this to test this insn
	#################

	mov	      $haddps2,%rcx
	call	      write_stdout  	# print "haddaps %xmm0,%xmm1"

        haddps        %xmm0,%xmm0
	
	# xmm1 = (s2+s3) + (s0+s1) + (d2+d3) + (d0+d1)
	#      =    12        3        12        3
			

	#################
	# Print result
	#################
	
	mov	      $xmm0_label,%rcx		# print xmm0=
	call	      write_stdout

	cvtps2dq      %xmm0,%xmm2 		# print value in xmm0
	call	      print_s_xmm2
 
	mov	      $should_be4,%rcx
	call	      write_stdout

	# check answers
	
	cvtps2dq      %xmm0,%xmm2 		# print value in xmm1

	mov	      $3,%r9d
	mov	      $12,%r10d
	mov	      $3,%r11d
	mov	      $12,%r12d
	call	      compare_s_xmm2



	#########################
	# test xmmm/mem
	#########################

	mov	      $xmm_mem_label,%rcx	# print heading
	call	      write_stdout
			
	cvtdq2ps      source1,%xmm0		# move 8,4,2,1 into xmm0

	mov	      $xmm0_label,%rcx		# print xmm0=
	call	      write_stdout

	cvtps2dq      %xmm0,%xmm2 		# print value in xmm0
	call	      print_s_xmm2

	mov	      $should_be1,%rcx
	call	      write_stdout
	
						
	cvtdq2ps      source2,%xmm1		# move 800,400,200,100 into xmm1
				
	mov	      $xmm1_label,%rcx		# print xmm0=
	call	      write_stdout

	cvtps2dq      %xmm1,%xmm2 		# print value in xmm0
	call	      print_s_xmm2

	mov	      $should_be2,%rcx
	call	      write_stdout				
						
        movaps        %xmm0,out			# move to memory


	mov	      $haddps3,%rcx
	call	      write_stdout				
								
	haddps        out,%xmm1			
	
        # xmm1 = (s2+s3) + (s0+s1) + (d2+d3) + (d0+d1)
        #      =    12        3        1200      300
		
	#################
	# Print result
	#################
	
	mov	      $xmm0_label,%rcx		# print xmm0=
	call	      write_stdout

	cvtps2dq      %xmm0,%xmm2 		# print value in xmm0
	call	      print_s_xmm2
	
	mov	      $xmm1_label,%rcx		# print xmm1=
	call	      write_stdout

	cvtps2dq      %xmm1,%xmm2 		# print value in xmm0
	call	      print_s_xmm2

 
	mov	      $should_be5,%rcx
	call	      write_stdout

	# check answers
	
	cvtps2dq      %xmm1,%xmm2 		# print value in xmm1

	mov	      $300,%r9d
	mov	      $1200,%r10d
	mov	      $3,%r11d
	mov	      $12,%r12d
	call	      compare_s_xmm2
	
	#########################
	# test xmmm/rel-ip
	#########################

	mov	      $xmm_rel_label,%rcx	# print heading
	call	      write_stdout
			
	cvtdq2ps      source1,%xmm0		# move 8,4,2,1 into xmm0

	mov	      $xmm0_label,%rcx		# print xmm0=
	call	      write_stdout

	cvtps2dq      %xmm0,%xmm2 		# print value in xmm0
	call	      print_s_xmm2

	mov	      $should_be1,%rcx
	call	      write_stdout
	
						
	cvtdq2ps      source2(%rip),%xmm1		# move 800,400,200,100 into xmm1
				
	mov	      $xmm1_label,%rcx		# print xmm0=
	call	      write_stdout

	cvtps2dq      %xmm1,%xmm2 		# print value in xmm0
	call	      print_s_xmm2

	mov	      $should_be2,%rcx
	call	      write_stdout				
						
        movaps        %xmm0,out(%rip)		# move to memory


	mov	      $haddps3,%rcx
	call	      write_stdout				
								
	haddps        out(%rip),%xmm1			
	
        # xmm1 = (s2+s3) + (s0+s1) + (d2+d3) + (d0+d1)
        #      =    12        3        1200      300
		
	#################
	# Print result
	#################
	
	mov	      $xmm0_label,%rcx		# print xmm0=
	call	      write_stdout

	cvtps2dq      %xmm0,%xmm2 		# print value in xmm0
	call	      print_s_xmm2
	
	mov	      $xmm1_label,%rcx		# print xmm1=
	call	      write_stdout

	cvtps2dq      %xmm1,%xmm2 		# print value in xmm0
	call	      print_s_xmm2

 
	mov	      $should_be5,%rcx
	call	      write_stdout

	# check answers
	
	cvtps2dq      %xmm1,%xmm2 		# print value in xmm1

	mov	      $300,%r9d
	mov	      $1200,%r10d
	mov	      $3,%r11d
	mov	      $12,%r12d
	call	      compare_s_xmm2
	


	#######################
	#
	# if we get here, all went well
	#
	#######################

	mov	$good_string,%rcx
	call	write_stdout	

	jmp	our_exit

fail:	
	mov	$bad_string,%rcx
	call	write_stdout	
	jmp	our_exit


	#######################
	# print_s_xmm2
	#######################
	# Print 4 s values in xmm2

print_s_xmm2:

	movd          %xmm2,%eax	# print first
	call          print_decimal
	mov	      $space,%rcx
	call	      write_stdout
	psrldq        $4,%xmm2
								
	movd 	      %xmm2,%eax	# print second
	call          print_decimal
	mov	      $space,%rcx
	call	      write_stdout		
	psrldq        $4,%xmm2

			     
	movd          %xmm2,%eax	# print third
	call          print_decimal
	mov	      $space,%rcx
	call	      write_stdout	
	psrldq        $4,%xmm2

        movd          %xmm2,%eax	# print fourth
	call          print_decimal		
	mov	      $space,%rcx
	call	      write_stdout
        call          print_lf
	
	ret
	
	#######################
	# compare_s_xmm2
	#######################
	# Compares 4 s values in xmm2
	# r9/r10/r11/r12
	
compare_s_xmm2:

	movd          %xmm2,%eax
	cmp           %r9d,%eax
        jne           fail
	psrldq        $4,%xmm2
								
	movd 	      %xmm2,%eax
	cmp           %r10d,%eax
        jne           fail
	psrldq        $4,%xmm2
	
	movd          %xmm2,%eax
	cmp           %r11d,%eax
	jne           fail
	psrldq        $4,%xmm2

        movd          %xmm2,%eax
	cmp           %r12d,%eax
	jne           fail

	ret

our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data
.balign 16
.balign 16
source1:                .int  1,2,4,8
source2:                .int 100,200,400,800
out:                    .int  16,17,18,19

temp:		.int  1,2,3,4
temp2:		.int  8,9,10,11

xmm_xmm_label:		.ascii  "\nxmm/xmm:\n\0"
xmm0_label:		.ascii	"           xmm0 = \0"
should_be1:             .ascii  "      should be = 1 2 4 8\n\0"
xmm1_label:		.ascii	"           xmm1 = \0"
should_be2:             .ascii  "      should be = 100 200 400 800\n\0"
should_be3:		.ascii	" Should be xmm0 = 1 2 4 8\n"
			.ascii	"           xmm1 = 300 1200 3 12\n\0"
haddps1:		.ascii  " haddps %xmm0,%xmm1\n\0"

xmm_same_label:		.ascii  "\nxmm/xmm same:\n\0"
haddps2:		.ascii  " haddps %xmm0,%xmm0\n\0"
should_be4:		.ascii	" Should be xmm0 = 3 12 3 12\n\0"

xmm_mem_label:		.ascii  "\nxmm/mem:\n\0"
haddps3:		.ascii  " haddps out,%xmm1\n\0"
should_be5:		.ascii	" Should be xmm0 = 1 2 4 8\n"
			.ascii	"           xmm1 = 300 1200 3 12\n\0"

xmm_rel_label:		.ascii  "\nxmm/rel-ip:\n\0"

space:		.ascii  " \0"

good_string:	.ascii	"Good\n\0"
bad_string:	.ascii	"Fail\n\0"
