
# This tests m5 unimplemented movdqa on x86_64

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	
	
	# move aligned 128-bit value from memory to XMM register

	movdqa  onetwentyeight,%xmm0
	movdqa	%xmm0,%xmm1
	movdqa	%xmm1,resultingstring

	mov	$resultingstring,%rcx
	call	write_stdout
	
	mov	resultingstring,%eax
	cmp	$0x33323130,%eax
	je	print_good
	
	mov	$bad_string,%rcx
	call	write_stdout
	jmp	our_exit
	
print_good:	
	mov	$good_string,%rcx
	call	write_stdout

our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data
.balign 16
onetwentyeight: .ascii  "0123456789ABCDEF"
.balign 16
resultingstring: .ascii "QWERTYUIOPASDFGH\n\0"
good_string:	.ascii	"Good\n\0"
bad_string:	.ascii	"Bad\n\0"
